/*
 * Copyright (c) 2012 NINTENDO.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions, and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions, and the following disclaimer in the 
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY NINTENDO AND ITS CONTRIBUTORS "AS IS" AND ANY 
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL NINTENDO OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef DEBUGIO_H
#define DEBUGIO_H

namespace LibPlatform {
	class DebugIO {
	public:
		typedef signed Handle;
		typedef signed Status;
		typedef unsigned ChannelOptions;
		typedef unsigned ChannelFlags;

		static Handle Open(
			const char *hio_name,
			void (*connection_callback)(Status status, void *context),
			void *context,
			ChannelOptions options,
			ChannelFlags flags
		);

		static Status ReadAsync(
			Handle handle, 
			unsigned size_in_bytes, 
			void *data, 
			void (*async_param)(Status status, void *context),
			void *context
		);

		static Status WriteAsync(
			Handle handle, 
			unsigned size_in_bytes, 
			void *data,
			void (*async_param)(Status status, void *context),
			void *context
		);

		static Status Write(
			Handle handle, 
			unsigned sizeInBytes, 
			const void *data
		);

		static Status Close(Handle handle);
	};
}

#endif//DEBUGIO_H